 /*
 * This is an adaptation of different codes from 2 different sources. Yeah, Im a stealing bastard.
 
 * I didn't write the PWM->PPM encoding. You can find the original one here (td) but all it does was 
 * encode into ppm values stored in an array. It doesn't read pwm however. His PWM->PPM encoder code
 * was working well to generate turnigy9x-like ppm signals. I'm still looking for an alternative be-
 * -cause I think this can be done faster.
 *
 * Now the problem is capturing pwm as FAST AS POSSIBLE!
 *
 * The solution came from doughboy's (rcgroups.com/multiwii.com) PWM->PPM encoder. I got it working once
 * and it somehow didn't work after that (most notably when I upgraded the openlrs firmware). But his example
 * was an inspiration-it's really fast (no jitter at all). 
 * But the downside is that the implementation makes it difficult to do anything about the pwm. No failsafe.
 * Iff it happen to interchange your channels, you have to reprogram your radio.
 *
 * jps1 @ rcgroups.com
 */
 
#define CHECK_BIT(var, pos) ((var) & (1<<(pos))) //macro for checking the value of a bit in a byte or a bitstream

#define chanel_number 8
#define default_servo_value 1500  //set the default servo value
#define PPM_FrLen 22500  //set the PPM frame length in microseconds (1ms = 1000µs)
#define PPM_PulseLen 300  //set the pulse length
#define onState 1  //set polarity of the pulses: 1 is positive, 0 is negative
#define sigPin 7  //set PPM signal output pin on the arduino

/*this array holds the servo values for the ppm signal
 change these values in your code (usually servo values move between 1000 and 2000)*/
volatile uint16_t ppm[chanel_number];

volatile uint32_t ulCh1Start;
volatile uint32_t ulCh2Start;
volatile uint32_t ulCh3Start;

volatile uint32_t m;
volatile uint8_t p;
volatile uint8_t b1;
volatile uint8_t b2;
volatile uint8_t b3;

void setup(){
  //init ppm array
  for(int i=0; i<chanel_number; i++){
    if(i == 2){                           //channel 3 set to low
      ppm[i] = 900;
    }else{
      ppm[i]= default_servo_value;
    }
  }
  
  pinMode(sigPin, OUTPUT);
  digitalWrite(sigPin, !onState);        //set the PPM signal pin to the default state (off)
  
  PCICR |= (1<<PCIE0);                   //Pin Change Interrupt 0
  PCMSK0 = 0b00000111;                   //interrupt on changes in pinb2, pinb3, pinb4 ; make sure you turn on other pins if you want more channels
  
  TCCR1A = 0;                            // set entire TCCR1 register to 0
  TCCR1B = 0; 
  OCR1A = 100;             // compare match register
  TCCR1B |= (1 << WGM12);  // turn on CTC mode
  TCCR1B |= (1 << CS11);   // 8 prescaler: 0,5 microseconds at 16mhz
  TIMSK1 |= (1 << OCIE1A); // enable timer compare interrupt

  sei();
  
  Serial.begin(9600);
}

void loop(){
}

void serialEvent() { //used this for displaying telemetry data from the uhf module

  while (Serial.available()) 
    Serial.write(Serial.read());
  
}


ISR(PCINT0_vect) {   
  
  m =  micros();
  p = PINB;
  b1= CHECK_BIT(p, 0); // I am inferring this is faster than digitalRead()? imhooo
  b2 = CHECK_BIT(p, 1);
  b3 = CHECK_BIT(p, 2);
  
  if(b1 && !ulCh1Start){
    ulCh1Start = m;
    return; // assuming that each call to this function is made by only a single pin change. so terminate it if this the pin.
  }else if(!b1 && ulCh1Start){
    ppm[0] = (uint16_t)(m - ulCh1Start); 
    ulCh1Start = 0;
    return;
  }
  
  if(b2 && !ulCh2Start){// I am inferring this is faster than digitalRead()
    ulCh2Start = m; 
    return;
  }else if(!b2 && ulCh2Start){
    ppm[1] = (uint16_t)(m - ulCh2Start);
    ulCh2Start = 0;
    return;
  }
  
  if(b3 && !ulCh3Start){// I am inferring this is faster than digitalRead()
    ulCh3Start = m; 
    return;
  }else if(!b3 && ulCh3Start){
    ppm[2] = (uint16_t)(m - ulCh3Start);
    ulCh3Start = 0;
    return;
  }
     
}

ISR(TIMER1_COMPA_vect){  //leave this alone. This is the part where ppm[] array gets converted into a ppm signal. Executes when TIMER1's counter  reaches OCR1A
  static boolean state = true;
  TCNT1 = 0;
  if(state) {  //start pulse
    digitalWrite(sigPin, onState);
    OCR1A = PPM_PulseLen * 2;
    state = false;
  }
  else{  //end pulse and calculate when to start the next pulse
    static byte cur_chan_numb;
    static unsigned int calc_rest;
  
    digitalWrite(sigPin, !onState);
    state = true;

    if(cur_chan_numb >= chanel_number){
      cur_chan_numb = 0;
      calc_rest = calc_rest + PPM_PulseLen;// 
      OCR1A = (PPM_FrLen - calc_rest) * 2;
      calc_rest = 0;
    }
    else{
      OCR1A = (ppm[cur_chan_numb] - PPM_PulseLen) * 2;
      calc_rest = calc_rest + ppm[cur_chan_numb];
      cur_chan_numb++;
    }     
  }
}
